!DIR$ FIXEDFORMLINESIZE:132
      subroutine find_qz(Mode, cqz, info, info_1, info_2)
      use dblocks
      use values
      implicit none
      integer*4,  intent(in)  :: Mode
      complex*16, intent(out) :: cqz
      integer*4 , intent(out) :: info, info_1, info_2

      complex*16, dimension(1:3) :: cq_ini, cq_sol 
      complex*16  beps_i, beps_h
      logical*4   flag

      external make_guess, solve_fixP, solve_ratA, reduce_toFBZ, check_sol

      info   = 0
      info_1 = 0
      info_2 = 0

      call make_guess(cq_ini)

      IF     (any(Method .eq. Meth_fxp)) THEN

         call solve_fixP(Mode, itm_1, cq_ini, cq_sol, info)

      ELSE IF(any(Method .eq. Meth_rap)) THEN

         call solve_ratA(1, Mode, itm_1, cq_ini, cq_sol, info)

      ELSE IF(any(Method .eq. Meth_eps)) THEN

         call solve_fixP(Mode, itm_1, cq_ini, cq_sol, info)
         if(info .eq. -1) then
            beps_i = ceps_i
            beps_h = ceps_h
            ceps_i = ceps_i + cu* dabs( dreal(ceps_i) )*efra
            ceps_h = ceps_h + cu* dabs( dreal(ceps_h) )*efra
            ceps_a = rho*ceps_i + (ru-rho)*ceps_h
            chi    = rho*(ceps_i - ceps_h)/ceps_h
            ckh2   = rk2*ceps_h 
            call make_guess(cq_ini)
            call solve_ratA(1, Mode, itm_2, cq_ini, cq_sol, info)
            if(info .gt. 0) then
               ceps_i = beps_i
               ceps_h = beps_h
               ceps_a = rho*ceps_i + (ru-rho)*ceps_h
               chi    = rho*(ceps_i - ceps_h)/ceps_h
               ckh2   = rk2*ceps_h 
               cq_ini = cq_sol
               call solve_ratA(2, Mode, itm_3, cq_ini, cq_sol, info)
            end if
         end if

      ELSE

         info = -100
         return

      END IF

      if(info .le. 0) return

      cqz = cq_sol(3)
      call reduce_toFBz(cqz, flag)
      if(flag) return

      cq_sol(3) = cqz
      call check_sol(Mode, cq_sol, flag)
      if(flag) return

      cq_ini = cq_sol

      call solve_ratA(2, Mode, itm_2, cq_ini, cq_sol, info_1)
      if(info_1 .gt. 0) then
         cqz = cq_sol(3)
         call reduce_toFBz(cqz, flag)
         if(flag) return
         cq_sol(3) = cqz
         call check_sol(Mode, cq_sol, flag)
         if(flag) return
      end if

      call solve_ratA(1, Mode, itm_2, cq_ini, cq_sol, info_2)
      if(info_2 .gt. 0) then
         cqz = cq_sol(3)
         call reduce_toFBz(cqz, flag)
         if(flag) return
         cq_sol(3) = cqz
         call check_sol(Mode, cq_sol, flag)
         if(flag) return
      end if

      info = -2

      return
      end
