!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine make_bx(cq, bx)
      use dblocks
      implicit none
      complex*16, intent(in)  :: cq(1:3)
      complex*16, intent(out) :: bx(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)

      complex*16 cden, cwx, cwy, cwz
      real*8     gx, gy, gz, Mg
      integer*4  nx, ny, nz, nx2, ny2, nz2, n2

      bx = cz

      do 1, nx=-Lx,Lx
      nx2 = nx*nx
      gx  = pi2*dfloat(nx)/hx
      cwx = gx + cq(1)
      
      do 1, ny=-Ly,Ly
      ny2 = ny*ny
      gy  = pi2*dfloat(ny)/hy
      cwy = gy + cq(2)

      do 1, nz=-Lz,Lz
      nz2 = nz*nz
      gz  = pi2*dfloat(nz)/hz
      cwz = gz + cq(3)

      n2  = nx2 + ny2 + nz2
      if(n2 .eq. 0) goto 1
      
      Mg = Mz(nz)*My(ny)*Mx(nx)

      cden = cwx**2 + cwy**2 + cwz**2 - ckh2 

      bx(1, nz, ny, nx) = Mg * (ckh2 - cwx*cwx) / cden
      bx(2, nz, ny, nx) = Mg * (cz   - cwy*cwx) / cden
      bx(3, nz, ny, nx) = Mg * (cz   - cwz*cwx) / cden

 1    continue

      return
      end
